//
// rational.cpp
// Bruno Heidelberger <heidelberger@inf.ethz.ch>
// 14. Jan. 2004
//

#include <iostream>
#include "rational.h"

using namespace std;

int Rational::getZaehler()
{
  return m_zaehler;
}

int Rational::getNenner()
{
  return m_nenner;
}

void Rational::set(int zaehler, int nenner)
{
  m_zaehler = zaehler;
  m_nenner = nenner;
}

void Rational::add(const Rational& r)
{
  m_zaehler = m_zaehler * r.m_nenner + r.m_zaehler * m_nenner;
  m_nenner = m_nenner * r.m_nenner;
  kuerzen();
}

void Rational::sub(const Rational& r)
{
  m_zaehler = m_zaehler * r.m_nenner - r.m_zaehler * m_nenner;
  m_nenner = m_nenner * r.m_nenner;
  kuerzen();
}

void Rational::mult(const Rational& r)
{
  m_zaehler = m_zaehler * r.m_zaehler;
  m_nenner = m_nenner * r.m_nenner;
  kuerzen();
}

void Rational::div(const Rational& r)
{
  m_zaehler = m_zaehler * r.m_nenner;
  m_nenner = m_nenner * r.m_zaehler;
  kuerzen();
}

int Rational::ggt(int x, int y)
{
  while(y > 0)
  {
    int rest = x % y;
    x = y;
    y = rest;
  }
  return x;
}

void Rational::kuerzen()
{
  int sign = 1;
  if(m_zaehler < 0) 
  {
    sign = -sign;
    m_zaehler = -m_zaehler;
  }
  if(m_nenner < 0)
  {
    sign = -sign;
    m_nenner = -m_nenner;
  }

  int teiler = ggt(m_zaehler, m_nenner);

  if(teiler > 0)
    {
      m_zaehler = sign * m_zaehler / teiler;
      m_nenner = m_nenner / teiler;
    }
}

void Rational::print()
{
  cout << m_zaehler << "/" << m_nenner << endl;
}

